{
    "$graph": [
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bam_readgroup_to_json:7cb045ba57c027e283fbf42ea566f39b5f4846b1381e69b9e36e32bb978f0c9a"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": 1,
                    "tmpdirMax": 1,
                    "outdirMin": 1,
                    "outdirMax": 1
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#bam_readgroup_to_json.cwl/INPUT",
                    "type": "File",
                    "format": "#bam_readgroup_to_json.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "--bam_path"
                    }
                },
                {
                    "id": "#bam_readgroup_to_json.cwl/MODE",
                    "type": "string",
                    "default": "strict",
                    "inputBinding": {
                        "prefix": "--mode"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bam_readgroup_to_json"
            ],
            "id": "#bam_readgroup_to_json.cwl",
            "outputs": [
                {
                    "id": "#bam_readgroup_to_json.cwl/OUTPUT",
                    "format": "#bam_readgroup_to_json.cwl/format_3464",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.json",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#bam_readgroup_to_json.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "output.log"
                    }
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/biobambam:533ed9be5fd34b177b5a906262c615bff1a4cdc2c84b78c2244cbd7283842120"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 2000,
                    "ramMax": 2000,
                    "tmpdirMin": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))",
                    "tmpdirMax": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))",
                    "outdirMin": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))",
                    "outdirMax": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#biobambam2_bamtofastq.cwl/collate",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "collate=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/exclude",
                    "type": "string",
                    "default": "QCFAIL,SECONDARY,SUPPLEMENTARY",
                    "inputBinding": {
                        "prefix": "exclude=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/filename",
                    "format": "#biobambam2_bamtofastq.cwl/format_2572",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "filename=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/gz",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "gz=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/inputformat",
                    "type": "string",
                    "default": "bam",
                    "inputBinding": {
                        "prefix": "inputformat=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/level",
                    "type": "int",
                    "default": 5,
                    "inputBinding": {
                        "prefix": "level=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputdir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "outputdir=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroup",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "outputperreadgroup=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixF",
                    "type": "string",
                    "default": "_1.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixF=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixF2",
                    "type": "string",
                    "default": "_2.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixF2=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixO",
                    "type": "string",
                    "default": "_o1.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixO=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixO2",
                    "type": "string",
                    "default": "_o2.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixO2=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixS",
                    "type": "string",
                    "default": "_s.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixS=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/tryoq",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "tryoq=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/T",
                    "type": "string",
                    "default": "tempfq",
                    "inputBinding": {
                        "prefix": "T=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq1",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq2",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_o1",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_o1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_o2",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_o2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_s",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_s.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bamtofastq"
            ],
            "id": "#biobambam2_bamtofastq.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastq_remove_duplicate_qname:de3c1fe6febe4e7a6bdee7638fdffc17f70c8be2602f8f3b25deb2e07d26e16d"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 5000,
                    "ramMax": 5000,
                    "tmpdirMin": "$(Math.ceil(inputs.INPUT.size / 1048576))",
                    "tmpdirMax": "$(Math.ceil(inputs.INPUT.size / 1048576))",
                    "outdirMin": "$(Math.ceil(inputs.INPUT.size / 1048576))",
                    "outdirMax": "$(Math.ceil(inputs.INPUT.size / 1048576))"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastq_remove_duplicate_qname.cwl/INPUT",
                    "type": "File",
                    "format": "#fastq_remove_duplicate_qname.cwl/format_2182"
                }
            ],
            "outputs": [
                {
                    "id": "#fastq_remove_duplicate_qname.cwl/OUTPUT",
                    "type": "File",
                    "format": "#fastq_remove_duplicate_qname.cwl/format_2182",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.basename)"
                    }
                },
                {
                    "id": "#fastq_remove_duplicate_qname.cwl/METRICS",
                    "type": "File",
                    "outputBinding": {
                        "glob": "fastq_dup_rm.log"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "${\n  var cmd = [\n  \"zcat\", inputs.INPUT.path, \"|\",\n  \"/usr/local/bin/fastq_remove_duplicate_qname\", \"-\", \"|\",\n  \"gzip\", \"-\", \">\", inputs.INPUT.basename\n  ];\n  return cmd.join(' ')\n}\n"
                }
            ],
            "baseCommand": [
                "bash",
                "-c"
            ],
            "id": "#fastq_remove_duplicate_qname.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastqc:27ec215ea82bd62a76ec86f9c8a692010cc0c99169e68d2fa0c0052450321f57"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)",
                    "coresMax": "$(inputs.threads)",
                    "ramMin": 5000,
                    "ramMax": 5000,
                    "tmpdirMin": 50,
                    "tmpdirMax": 50,
                    "outdirMin": 5,
                    "outdirMax": 5
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastqc.cwl/adapters",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--adapters"
                    }
                },
                {
                    "id": "#fastqc.cwl/casava",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--casava"
                    }
                },
                {
                    "id": "#fastqc.cwl/contaminants",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--contaminants"
                    }
                },
                {
                    "id": "#fastqc.cwl/dir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "--dir"
                    }
                },
                {
                    "id": "#fastqc.cwl/extract",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--extract"
                    }
                },
                {
                    "id": "#fastqc.cwl/format",
                    "type": "string",
                    "default": "fastq",
                    "inputBinding": {
                        "prefix": "--format"
                    }
                },
                {
                    "id": "#fastqc.cwl/INPUT",
                    "type": "File",
                    "format": "#fastqc.cwl/format_2182",
                    "inputBinding": {
                        "position": 99
                    }
                },
                {
                    "id": "#fastqc.cwl/kmers",
                    "type": "long",
                    "default": 7,
                    "inputBinding": {
                        "prefix": "--kmers"
                    }
                },
                {
                    "id": "#fastqc.cwl/limits",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--limits"
                    }
                },
                {
                    "id": "#fastqc.cwl/nano",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--nano"
                    }
                },
                {
                    "id": "#fastqc.cwl/noextract",
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "--noextract"
                    }
                },
                {
                    "id": "#fastqc.cwl/nofilter",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--nofilter"
                    }
                },
                {
                    "id": "#fastqc.cwl/nogroup",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--nogroup"
                    }
                },
                {
                    "id": "#fastqc.cwl/outdir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "--outdir"
                    }
                },
                {
                    "id": "#fastqc.cwl/quiet",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--quiet"
                    }
                },
                {
                    "id": "#fastqc.cwl/threads",
                    "type": "long",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--threads"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*_fastqc.zip"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/FastQC/fastqc"
            ],
            "id": "#fastqc.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastqc_db:3383ae9c9beaf905682b21cab14d20b3bc4fc738c7e1e126da99dc288ba016ac"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": 100,
                    "tmpdirMax": 100,
                    "outdirMin": 10,
                    "outdirMax": 10
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastqc_db.cwl/INPUT",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--INPUT"
                    }
                },
                {
                    "id": "#fastqc_db.cwl/job_uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--job_uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc_db.cwl/LOG",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + \".log\")"
                    }
                },
                {
                    "id": "#fastqc_db.cwl/OUTPUT",
                    "type": "File",
                    "format": "#fastqc_db.cwl/format_3621",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/fastqc_db"
            ],
            "id": "#fastqc_db.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/merge_sqlite:1b3a6f55be8579ecfb4c9c0513c3b710717a8f4cd8e79c88ee8c0f28f604faa3"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": "${\nvar req_space = 0;\nfor (var i = 0; i < inputs.source_sqlite.length; i++) {\n    req_space += inputs.source_sqlite[i].size;\n  }\nreturn Math.ceil(2 * (req_space / 1048576));\n}      \n",
                    "tmpdirMax": "${\nvar req_space = 0;\nfor (var i = 0; i < inputs.source_sqlite.length; i++) {\n    req_space += inputs.source_sqlite[i].size;\n  }\nreturn Math.ceil(2 * (req_space / 1048576));\n}      \n",
                    "outdirMin": "${\nvar req_space = 0;\nfor (var i = 0; i < inputs.source_sqlite.length; i++) {\n    req_space += inputs.source_sqlite[i].size;\n  }\nreturn Math.ceil(req_space / 1048576);\n}      \n",
                    "outdirMax": "${\nvar req_space = 0;\nfor (var i = 0; i < inputs.source_sqlite.length; i++) {\n    req_space += inputs.source_sqlite[i].size;\n  }\nreturn Math.ceil(req_space / 1048576);\n}\n"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#merge_sqlite.cwl/source_sqlite",
                    "format": "#merge_sqlite.cwl/format_3621",
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "--source_sqlite"
                        }
                    }
                },
                {
                    "id": "#merge_sqlite.cwl/job_uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--job_uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#merge_sqlite.cwl/destination_sqlite",
                    "format": "#merge_sqlite.cwl/format_3621",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + \".db\")"
                    }
                },
                {
                    "id": "#merge_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + \".log\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/merge_sqlite"
            ],
            "id": "#merge_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/readgroup_json_db:d1c36c48491afa45c76c23624ecf69b37b4f276019cb6e168364f564452e5b37"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": 1,
                    "tmpdirMax": 1,
                    "outdirMin": 1,
                    "outdirMax": 1
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#readgroup_json_db.cwl/json_path",
                    "type": "File",
                    "format": "#readgroup_json_db.cwl/format_3464",
                    "inputBinding": {
                        "prefix": "--json_path"
                    }
                },
                {
                    "id": "#readgroup_json_db.cwl/job_uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--job_uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#readgroup_json_db.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid +\".log\")"
                    }
                },
                {
                    "id": "#readgroup_json_db.cwl/output_sqlite",
                    "type": "File",
                    "format": "#readgroup_json_db.cwl/format_3621",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/readgroup_json_db"
            ],
            "id": "#readgroup_json_db.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#sort_scatter_expression.cwl/INPUT",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#sort_scatter_expression.cwl/OUTPUT",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                }
            ],
            "expression": "${\n  var output = inputs.INPUT.sort(function(a,b) { return a.basename > b.basename ? 1 : (a.basename < b.basename ? -1 : 0) });\n  return {'OUTPUT': output}\n}\n",
            "id": "#sort_scatter_expression.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/input_bam",
                    "type": "File"
                },
                {
                    "id": "#main/thread_count",
                    "type": "long"
                },
                {
                    "id": "#main/job_uuid",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#main/sqlite",
                    "type": "File",
                    "outputSource": "#main/merge_all_sqlite/destination_sqlite"
                }
            ],
            "steps": [
                {
                    "id": "#main/biobambam_bamtofastq",
                    "run": "#biobambam2_bamtofastq.cwl",
                    "in": [
                        {
                            "id": "#main/biobambam_bamtofastq/filename",
                            "source": "#main/input_bam"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq1"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq2"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq_o1"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq_o2"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq_s"
                        }
                    ]
                },
                {
                    "id": "#main/remove_duplicate_fastq1",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#main/remove_duplicate_fastq1/INPUT",
                    "in": [
                        {
                            "id": "#main/remove_duplicate_fastq1/INPUT",
                            "source": "#main/biobambam_bamtofastq/output_fastq1"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/remove_duplicate_fastq1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/remove_duplicate_fastq2",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#main/remove_duplicate_fastq2/INPUT",
                    "in": [
                        {
                            "id": "#main/remove_duplicate_fastq2/INPUT",
                            "source": "#main/biobambam_bamtofastq/output_fastq2"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/remove_duplicate_fastq2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/remove_duplicate_fastq_o1",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#main/remove_duplicate_fastq_o1/INPUT",
                    "in": [
                        {
                            "id": "#main/remove_duplicate_fastq_o1/INPUT",
                            "source": "#main/biobambam_bamtofastq/output_fastq_o1"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/remove_duplicate_fastq_o1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/remove_duplicate_fastq_o2",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#main/remove_duplicate_fastq_o2/INPUT",
                    "in": [
                        {
                            "id": "#main/remove_duplicate_fastq_o2/INPUT",
                            "source": "#main/biobambam_bamtofastq/output_fastq_o2"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/remove_duplicate_fastq_o2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/remove_duplicate_fastq_s",
                    "run": "#fastq_remove_duplicate_qname.cwl",
                    "scatter": "#main/remove_duplicate_fastq_s/INPUT",
                    "in": [
                        {
                            "id": "#main/remove_duplicate_fastq_s/INPUT",
                            "source": "#main/biobambam_bamtofastq/output_fastq_s"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/remove_duplicate_fastq_s/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/sort_scattered_fastq1",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#main/sort_scattered_fastq1/INPUT",
                            "source": "#main/remove_duplicate_fastq1/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/sort_scattered_fastq1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/sort_scattered_fastq2",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#main/sort_scattered_fastq2/INPUT",
                            "source": "#main/remove_duplicate_fastq2/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/sort_scattered_fastq2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/sort_scattered_fastq_o1",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#main/sort_scattered_fastq_o1/INPUT",
                            "source": "#main/remove_duplicate_fastq_o1/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/sort_scattered_fastq_o1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/sort_scattered_fastq_o2",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#main/sort_scattered_fastq_o2/INPUT",
                            "source": "#main/remove_duplicate_fastq_o2/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/sort_scattered_fastq_o2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/sort_scattered_fastq_s",
                    "run": "#sort_scatter_expression.cwl",
                    "in": [
                        {
                            "id": "#main/sort_scattered_fastq_s/INPUT",
                            "source": "#main/remove_duplicate_fastq_s/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/sort_scattered_fastq_s/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/bam_readgroup_to_json",
                    "run": "#bam_readgroup_to_json.cwl",
                    "in": [
                        {
                            "id": "#main/bam_readgroup_to_json/INPUT",
                            "source": "#main/input_bam"
                        },
                        {
                            "id": "#main/bam_readgroup_to_json/MODE",
                            "valueFrom": "lenient"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/bam_readgroup_to_json/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/readgroup_json_db",
                    "run": "#readgroup_json_db.cwl",
                    "scatter": "#main/readgroup_json_db/json_path",
                    "in": [
                        {
                            "id": "#main/readgroup_json_db/json_path",
                            "source": "#main/bam_readgroup_to_json/OUTPUT"
                        },
                        {
                            "id": "#main/readgroup_json_db/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/readgroup_json_db/log"
                        },
                        {
                            "id": "#main/readgroup_json_db/output_sqlite"
                        }
                    ]
                },
                {
                    "id": "#main/merge_readgroup_json_db",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/merge_readgroup_json_db/source_sqlite",
                            "source": "#main/readgroup_json_db/output_sqlite"
                        },
                        {
                            "id": "#main/merge_readgroup_json_db/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge_readgroup_json_db/destination_sqlite"
                        },
                        {
                            "id": "#main/merge_readgroup_json_db/log"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc1",
                    "run": "#fastqc.cwl",
                    "scatter": "#main/fastqc1/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc1/INPUT",
                            "source": "#main/sort_scattered_fastq1/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc1/threads",
                            "source": "#main/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc2",
                    "run": "#fastqc.cwl",
                    "scatter": "#main/fastqc2/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc2/INPUT",
                            "source": "#main/sort_scattered_fastq2/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc2/threads",
                            "source": "#main/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_s",
                    "run": "#fastqc.cwl",
                    "scatter": "#main/fastqc_s/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc_s/INPUT",
                            "source": "#main/sort_scattered_fastq_s/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc_s/threads",
                            "source": "#main/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_s/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_o1",
                    "run": "#fastqc.cwl",
                    "scatter": "#main/fastqc_o1/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc_o1/INPUT",
                            "source": "#main/sort_scattered_fastq_o1/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc_o1/threads",
                            "source": "#main/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_o1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_o2",
                    "run": "#fastqc.cwl",
                    "scatter": "#main/fastqc_o2/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc_o2/INPUT",
                            "source": "#main/sort_scattered_fastq_o2/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc_o2/threads",
                            "source": "#main/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_o2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_db1",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#main/fastqc_db1/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc_db1/INPUT",
                            "source": "#main/fastqc1/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc_db1/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_db1/LOG"
                        },
                        {
                            "id": "#main/fastqc_db1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_db2",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#main/fastqc_db2/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc_db2/INPUT",
                            "source": "#main/fastqc2/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc_db2/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_db2/LOG"
                        },
                        {
                            "id": "#main/fastqc_db2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_db_s",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#main/fastqc_db_s/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc_db_s/INPUT",
                            "source": "#main/fastqc_s/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc_db_s/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_db_s/LOG"
                        },
                        {
                            "id": "#main/fastqc_db_s/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_db_o1",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#main/fastqc_db_o1/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc_db_o1/INPUT",
                            "source": "#main/fastqc_o1/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc_db_o1/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_db_o1/LOG"
                        },
                        {
                            "id": "#main/fastqc_db_o1/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_db_o2",
                    "run": "#fastqc_db.cwl",
                    "scatter": "#main/fastqc_db_o2/INPUT",
                    "in": [
                        {
                            "id": "#main/fastqc_db_o2/INPUT",
                            "source": "#main/fastqc_o2/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc_db_o2/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_db_o2/LOG"
                        },
                        {
                            "id": "#main/fastqc_db_o2/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/merge_fastqc_db1_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/merge_fastqc_db1_sqlite/source_sqlite",
                            "source": "#main/fastqc_db1/OUTPUT"
                        },
                        {
                            "id": "#main/merge_fastqc_db1_sqlite/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge_fastqc_db1_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#main/merge_fastqc_db1_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#main/merge_fastqc_db2_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/merge_fastqc_db2_sqlite/source_sqlite",
                            "source": "#main/fastqc_db2/OUTPUT"
                        },
                        {
                            "id": "#main/merge_fastqc_db2_sqlite/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge_fastqc_db2_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#main/merge_fastqc_db2_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#main/merge_fastqc_db_s_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/merge_fastqc_db_s_sqlite/source_sqlite",
                            "source": "#main/fastqc_db_s/OUTPUT"
                        },
                        {
                            "id": "#main/merge_fastqc_db_s_sqlite/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge_fastqc_db_s_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#main/merge_fastqc_db_s_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#main/merge_fastqc_db_o1_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/merge_fastqc_db_o1_sqlite/source_sqlite",
                            "source": "#main/fastqc_db_o1/OUTPUT"
                        },
                        {
                            "id": "#main/merge_fastqc_db_o1_sqlite/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge_fastqc_db_o1_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#main/merge_fastqc_db_o1_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#main/merge_fastqc_db_o2_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/merge_fastqc_db_o2_sqlite/source_sqlite",
                            "source": "#main/fastqc_db_o2/OUTPUT"
                        },
                        {
                            "id": "#main/merge_fastqc_db_o2_sqlite/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge_fastqc_db_o2_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#main/merge_fastqc_db_o2_sqlite/log"
                        }
                    ]
                },
                {
                    "id": "#main/merge_all_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/merge_all_sqlite/source_sqlite",
                            "source": [
                                "#main/merge_readgroup_json_db/destination_sqlite",
                                "#main/merge_fastqc_db1_sqlite/destination_sqlite",
                                "#main/merge_fastqc_db2_sqlite/destination_sqlite",
                                "#main/merge_fastqc_db_s_sqlite/destination_sqlite",
                                "#main/merge_fastqc_db_o1_sqlite/destination_sqlite",
                                "#main/merge_fastqc_db_o2_sqlite/destination_sqlite"
                            ]
                        },
                        {
                            "id": "#main/merge_all_sqlite/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge_all_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#main/merge_all_sqlite/log"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
